package dev.shadowsoffire.apotheosis.ench.table;

import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.util.RandomSource;
import java.util.Iterator;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.item.EnchantedBookItem;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.EnchantmentInstance;
import java.util.List;
import net.minecraft.world.item.ItemStack;

public interface IEnchantableItem
{
    default ItemStack onEnchantment(ItemStack stack, final List<EnchantmentInstance> enchantments) {
        final boolean isBook = stack.m_150930_(Items.f_42517_);
        if (isBook) {
            final ItemStack enchBook = new ItemStack((ItemLike)Items.f_42690_);
            final CompoundTag tag = stack.m_41783_();
            if (tag != null) {
                stack.m_41751_(tag.m_6426_());
            }
            stack = enchBook;
        }
        for (final EnchantmentInstance inst : enchantments) {
            if (isBook) {
                EnchantedBookItem.m_41153_(stack, inst);
            }
            else {
                stack.m_41663_(inst.f_44947_, inst.f_44948_);
            }
        }
        return stack;
    }
    
    default List<EnchantmentInstance> selectEnchantments(final List<EnchantmentInstance> builtList, final RandomSource rand, final ItemStack stack, final int level, final float quanta, final float arcana, final boolean treasure) {
        return builtList;
    }
    
    default boolean forciblyAllowsTableEnchantment(final ItemStack stack, final Enchantment enchantment) {
        return stack.m_150930_(Items.f_42517_) && enchantment.isAllowedOnBooks();
    }
    
    default boolean isTreasureAllowed(final ItemStack stack, final boolean wasTreasureAllowed) {
        return wasTreasureAllowed;
    }
}
